| ghc-6.10.4: The GHC API | Contents | Index

HsDecls

Documentation
data HsDecl id

Constructors

TyClD (TyClDecl id) |
InstD (InstDecl id) |
DerivD (DerivDecl id) |
ValD (HsBind id) |
SigD (Sig id) |
DefD (DefaultDecl id) |
ForD (ForeignDecl id) |
WarningD (WarnDecl id) |
RuleD (RuleDecl id) |
SpliceD (SpliceDecl id) |
DocD (DocDecl id) |

Instances

OutputableBndr name => Outputable (HsDecl name)

type LHsDecl id = Located (HsDecl id)
data TyClDecl name

Constructors

ForeignType |

tcdLName :: Located name |
tcdExtName :: Maybe FastString |
tcdFoType :: FoType |

TyFamily |

tcdFlavour :: FamilyFlavour |
tcdLName :: Located name |
tcdTyVars :: [LHsTyVarBndr name] |
tcdKind :: Maybe Kind |

TyData |

tcdND :: NewOrData |
tcdCtxt :: LHsContext name |
tcdLName :: Located name |
tcdTyVars :: [LHsTyVarBndr name] |
tcdTyPats :: Maybe [LHsType name] |
tcdKindSig :: Maybe Kind |
tcdCons :: [LConDecl name] |
tcdDerivs :: Maybe [LHsType name] |

TySynonym |

tcdLName :: Located name |
tcdTyVars :: [LHsTyVarBndr name] |
tcdTyPats :: Maybe [LHsType name] |
tcdSynRhs :: LHsType name |

ClassDecl |

tcdCtxt :: LHsContext name |
tcdLName :: Located name |
tcdTyVars :: [LHsTyVarBndr name] |
tcdFDs :: [Located (FunDep name)] |
tcdSigs :: [LSig name] |
tcdMeths :: LHsBinds name |
tcdATs :: [LTyClDecl name] |
tcdDocs :: [LDocDecl name] |

Instances

OutputableBndr name => Outputable (TyClDecl name)

type LTyClDecl name = Located (TyClDecl name)
data InstDecl name

Constructors

InstDecl (LHsType name) (LHsBinds name) [LSig name] [LTyClDecl name] |

Instances

OutputableBndr name => Outputable (InstDecl name)

type LInstDecl name = Located (InstDecl name)
data DerivDecl name

Constructors

DerivDecl (LHsType name) |

Instances

OutputableBndr name => Outputable (DerivDecl name)

type LDerivDecl name = Located (DerivDecl name)
data NewOrData

Constructors

NewType |
DataType |

Instances

Eq NewOrData
Outputable NewOrData

data FamilyFlavour

Constructors

TypeFamily |
DataFamily |

data RuleDecl name

Constructors

HsRule RuleName Activation [RuleBndr name] (Located (HsExpr name)) NameSet (Located (HsExpr name)) NameSet |

Instances

OutputableBndr name => Outputable (RuleDecl name)

type LRuleDecl name = Located (RuleDecl name)
data RuleBndr name

Constructors

RuleBndr (Located name) |
RuleBndrSig (Located name) (LHsType name) |

Instances

OutputableBndr name => Outputable (RuleBndr name)

data DefaultDecl name

Constructors

DefaultDecl [LHsType name] |

Instances

OutputableBndr name => Outputable (DefaultDecl name)

type LDefaultDecl name = Located (DefaultDecl name)
data SpliceDecl id

Constructors

SpliceDecl (Located (HsExpr id)) |

Instances

OutputableBndr name => Outputable (SpliceDecl name)

data ForeignDecl name

Constructors

ForeignImport (Located name) (LHsType name) ForeignImport |
ForeignExport (Located name) (LHsType name) ForeignExport |

Instances

OutputableBndr name => Outputable (ForeignDecl name)

type LForeignDecl name = Located (ForeignDecl name)
data ForeignImport

Constructors

CImport CCallConv Safety FastString FastString CImportSpec |
DNImport DNCallSpec |

Instances

Outputable ForeignImport

data ForeignExport

Constructors

CExport CExportSpec |
DNExport |

Instances

Outputable ForeignExport

data CImportSpec

Constructors

CLabel CLabelString |
CFunction CCallTarget |
CWrapper |

data FoType

Constructors

DNType |

Instances

Eq FoType
Outputable FoType

data ConDecl name

Constructors

ConDecl |

con_name :: Located name |
con_explicit :: HsExplicitForAll |
con_qvars :: [LHsTyVarBndr name] |
con_cxt :: LHsContext name |
con_details :: HsConDeclDetails name |
con_res :: ResType name |
con_doc :: Maybe (LHsDoc name) |

Instances

OutputableBndr name => Outputable (ConDecl name)

data ResType name

Constructors

ResTyH98 |
ResTyGADT (LHsType name) |

data ConDeclField name

Constructors

ConDeclField |

cd_fld_name :: Located name |
cd_fld_type :: LBangType name |
cd_fld_doc :: Maybe (LHsDoc name) |

type LConDecl name = Located (ConDecl name)
type HsConDeclDetails name = HsConDetails (LBangType name) [ConDeclField name]
hsConDeclArgTys :: HsConDeclDetails name -> [LBangType name]
data DocDecl name

Constructors

DocCommentNext (HsDoc name) |
DocCommentPrev (HsDoc name) |
DocCommentNamed String (HsDoc name) |
DocGroup Int (HsDoc name) |

Instances

Outputable (DocDecl name)

type LDocDecl name = Located (DocDecl name)
docDeclDoc :: DocDecl name -> HsDoc name
data WarnDecl name

Constructors

Warning name WarningTxt |

Instances

OutputableBndr name => Outputable (WarnDecl name)

type LWarnDecl name = Located (WarnDecl name)
data HsGroup id

Constructors

HsGroup |

hs_valds :: HsValBinds id |
hs_tyclds :: [LTyClDecl id] |
hs_instds :: [LInstDecl id] |
hs_derivds :: [LDerivDecl id] |
hs_fixds :: [LFixitySig id] |
hs_defds :: [LDefaultDecl id] |
hs_fords :: [LForeignDecl id] |
hs_warnds :: [LWarnDecl id] |
hs_ruleds :: [LRuleDecl id] |
hs_docs :: [LDocDecl id] |

Instances

OutputableBndr name => Outputable (HsGroup name)

emptyRdrGroup :: HsGroup a
emptyRnGroup :: HsGroup a
appendGroups :: HsGroup a -> HsGroup a -> HsGroup a
tcdName :: TyClDecl name -> name
tyClDeclNames :: Eq name => TyClDecl name -> [Located name]
tyClDeclTyVars :: TyClDecl name -> [LHsTyVarBndr name]
isClassDecl :: TyClDecl name -> Bool
isSynDecl :: TyClDecl name -> Bool
isDataDecl :: TyClDecl name -> Bool
isTypeDecl :: TyClDecl name -> Bool
isFamilyDecl :: TyClDecl name -> Bool
isFamInstDecl :: TyClDecl name -> Bool
countTyClDecls :: [TyClDecl name] -> (Int, Int, Int, Int, Int, Int)
instDeclATs :: InstDecl name -> [LTyClDecl name]
collectRuleBndrSigTys :: [RuleBndr name] -> [LHsType name]
Produced by Haddock version 2.4.2